import argparse
from pathlib import Path


def get_parser(module_name: str, description: str) -> argparse.ArgumentParser:
    parser = argparse.ArgumentParser(
        prog=f"python3 -m karaokatalog.{module_name}",
        description=description,
    )

    parser.add_argument(
        "library_path",
        type=Path,
        help="The directory which contains the songs, the one you'd also configure UltraStar Deluxe to use",
    )

    return parser
