from dataclasses import dataclass
from pathlib import Path

from karaokatalog.instructions.Instruction import Instruction


@dataclass(frozen=True)
class RecodeInstruction(Instruction):
    """
    Open the file at the given path with the given old encoding, and save it with the given new encoding.
    """

    path: Path
    old_encoding: str
    new_encoding: str

    def __call__(self) -> None:
        with self.path.open("r", encoding=self.old_encoding) as f:
            file_contents = f.read()

        with self.path.open("w", encoding=self.new_encoding) as f:
            f.write(file_contents)
