import json
import logging

from karaokatalog.get_parser import get_parser
from karaokatalog.Library import Library

logging.basicConfig(
    format="%(asctime)s [%(levelname)s] %(message)s", level=logging.INFO
)


if __name__ == "__main__":
    args = get_parser(
        "jsonify", "Create a JSON file containing metadata of all songs in the library"
    ).parse_args()
    logging.info("Karaokatalog Jsonification started")

    logging.info("Loading library")
    library = Library.from_dir(args.library_path)
    logging.info("Library loaded")

    songs = [song.as_dict() for song in library.songs]
    json_path = args.library_path / "songs.json"

    logging.info(f"Writing JSON to {json_path}")

    with json_path.open("x", encoding="utf-8") as f:
        json.dump(songs, f, ensure_ascii=False, indent=4)

    logging.info("Karaokatalog Jsonification done")
