from collections.abc import Sequence

from flask import Flask, Response


def get_flask_app(songs: Sequence[dict[str, str]]) -> Flask:
    app = Flask("karaokatalog.ui", static_url_path="/")

    # This is only to make the type checker happy.
    songs_list = list(songs)

    @app.get("/songs.json")
    def get_songs() -> list[dict[str, str]]:
        return songs_list

    @app.get("/")
    def get_index() -> Response:
        return app.send_static_file("index.html")

    return app
